package edu.emory.mathcs;

import java.util.HashMap;
import java.util.Map;
import java.util.Set;

import edu.emory.mathcs.measures.Measure;
import edu.emory.mathcs.measures.privacy.DisclosureProbability;
import edu.emory.mathcs.privacy.PrivacyChecker;

@Deprecated
// Use CorruptionAttack
public class AllButOneCorruptionAttack
{

	public static Map<Site, Boolean> arePrivate(TuplesGroup tuples, PrivacyChecker checker)
	{
		Map<Site, Boolean> arePrivate = new HashMap<Site, Boolean>();
		Set<Site> sites = tuples.getSiteFrequencies().keySet();

		for (Site site : sites)
		{
			corruptAllButOneSiteTuples(tuples, site);

			arePrivate.put(site, checker.isAnonymized(tuples));

			uncorruptAllButOneSiteTuples(tuples, site);
		}

		return arePrivate;
	}

	public static Map<Site, Double> getValue(TuplesGroup tuples, Measure m)
	{
		Map<Site, Double> values = new HashMap<Site, Double>();
		Set<Site> sites = tuples.getSiteFrequencies().keySet();

		for (Site site : sites)
		{
			corruptAllButOneSiteTuples(tuples, site);

			values.put(site, m.getValue(tuples));

			uncorruptAllButOneSiteTuples(tuples, site);
		}

		return values;
	}

	public static Map<Site, Map<Tuple, Double>> getProbabilities(TuplesGroup tuples)
	{
		Map<Site, Map<Tuple, Double>> values = new HashMap<Site, Map<Tuple, Double>>();
		Set<Site> sites = tuples.getSiteFrequencies().keySet();

		for (Site site : sites)
		{
			corruptAllButOneSiteTuples(tuples, site);

			values.put(site, DisclosureProbability.getDisclosureProbabilities(tuples));

			uncorruptAllButOneSiteTuples(tuples, site);
		}

		return values;
	}
	
	private static TuplesGroup corruptAllButOneSiteTuples(TuplesGroup tuples, Site site)
	{
		for (Tuple t : tuples.getTuples())
		{
			if (t.getSite().compareTo(site) != 0)
				t.setCorrupted(true);
		}
		
		tuples.clearAttributeRanges();

		return tuples;
	}

	private static TuplesGroup uncorruptAllButOneSiteTuples(TuplesGroup tuples, Site site)
	{
		for (Tuple t : tuples.getTuples())
		{
			if (t.getSite().compareTo(site) != 0)
				t.setCorrupted(false);
		}

		tuples.clearAttributeRanges();

		return tuples;
	}

	public static int getNumberDisclosingSites(TuplesGroup tuples, PrivacyChecker checker)
	{
		Map<Site, Boolean> arePrivate = arePrivate(tuples, checker);

		int counter = 0;
		for (Boolean b : arePrivate.values())
			if (b == false)
				counter++;

		return counter;
	}
}
