package edu.emory.mathcs;

import java.util.Iterator;
import java.util.TreeMap;

public class SitesFactory {

	private static TreeMap<Integer, Site> sites = new TreeMap<Integer, Site>();
	
	private SitesFactory() {
	}
	
	public static Site getSite(int id) {
		
		Site site = SitesFactory.sites.get(id);
		
		if (site == null)
		{
			site = new Site(id);
			SitesFactory.sites.put(id, site);
		}
		
		return site;
	}
	
	public static final int getNumSites() {
		return SitesFactory.sites.size();
	}
	
	public static final Iterator<Site> iterator()
	{
		return SitesFactory.sites.values().iterator();
	}
}
