package edu.emory.mathcs;

public class Test
{

	public static void main(String[] args)
	{
		System.out.println(xMethod(5, 500L));
		final int tries = 1000000;
		int[] c = new int[10];
		for (int i = 0; i < tries; i++)
			c[myRandom(3, 0.8)]++;

		for (int i = 0; i < 10; i++)
			System.out
					.println(i + ": " + c[i] + " (" + c[i] / (double) tries + ")");

		System.out.println(convert(5, 2));
		System.out.println(convert(5, 3));
		System.out.println(convert(35, 16));
		System.out.println(convert(27, 16));
	}

	public static int xMethod(int n, long l)
	{
		System.out.println("int, long");
		reportValue(n);
		return n;
	}

	public static long xMethod(long n, long l)
	{
		reportValue(n);
		System.out.println("long, long");
		return n;
	}

	public static void reportValue(long x)
	{
		System.out.println("Reporting value: " + x);
	}

	public static int myRandom(int n, double p)
	{

		// Return n with a probability p
		double shouldBeN = Math.random();
		if (shouldBeN < p)
			return n;

		// randomly pick one of the other 9 numbers
		int number = (int) (Math.random() * 9);
		// if number is 'n' - return 9;
		if (number == n)
			number = 9;

		return number;
	}

	public static char getDigit(int value, int system)
	{
		if (value < 10)
			return (char) ('0' + value);

		return (char) ('A' + (value - 10));
	}

	public static String convert(long number, int system)
	{
		String convertedNumber = "";

		while (number > 0)
		{
			int digit = (int) (number % system);
			convertedNumber = getDigit(digit, system) + convertedNumber;
			number /= system;
		}

		return convertedNumber;
	}
}
