package edu.emory.mathcs.measures;

import java.util.Set;
import java.util.TreeSet;

import edu.emory.mathcs.Site;
import edu.emory.mathcs.Tuple;
import edu.emory.mathcs.TuplesGroup;

public class CountSites implements Measure
{

	public static final String NAME = "CountSites";

	@Override
	public double getBetterScore(double score1, double score2)
	{
		return Double.NaN;
	}

	@Override
	public double getMaxValue(Tuple[] tuples)
	{
		if (tuples.length == 0)
			return Double.NaN;

		Set<Site> sites = new TreeSet<Site>();

		for (Tuple tuple : tuples)
			sites.add(tuple.getSite());

		return sites.size();
	}

	@Override
	public double getMinValue(Tuple[] tuples)
	{
		if (tuples.length == 0)
			return Double.NaN;

		return 0.0;
	}

	@Override
	public String getName()
	{
		return CountSites.NAME;
	}

	@Override
	public double getValue(TuplesGroup tuples)
	{
		return tuples.getNumRepresentedSites();
	}

	@Override
	public int compareTo(Measure o)
	{
		return o.getName().compareTo(this.getName());
	}

	@Override
	public double getCombinedMeasureValue(double leftValue, double rightValue)
	{
		return Double.NaN;
	}

}
