package edu.emory.mathcs.measures;

import edu.emory.mathcs.Tuple;
import edu.emory.mathcs.TuplesGroup;

public class Count_diverse implements Measure
{

	public static final String NAME = "l_diverse";

	@Override
	public double getBetterScore(double score1, double score2)
	{
		return Math.max(score1, score2);
	}

	@Override
	public double getCombinedMeasureValue(double leftValue, double rightValue)
	{
		return Math.max(leftValue, rightValue);
	}

	@Override
	public double getMaxValue(Tuple[] tuples)
	{
		// TODO
		return Double.NaN;
	}

	@Override
	public double getMinValue(Tuple[] tuples)
	{
		return 1;
	}

	@Override
	public String getName()
	{
		return Count_diverse.NAME;
	}

	@Override
	public double getValue(TuplesGroup tuples)
	{
		return tuples.getAttributeFrequenciesUncorrupted(TuplesGroup.SENSITIVE).size();
	}

	@Override
	public int compareTo(Measure arg0)
	{
		return this.getName().compareTo(arg0.getName());
	}

}
