package edu.emory.mathcs.measures;

import edu.emory.mathcs.Tuple;
import edu.emory.mathcs.TuplesGroup;

public interface Measure extends Comparable<Measure> {

	public double getValue(final TuplesGroup tuples);
	
	public double getMinValue(final Tuple[] tuples);

	public double getMaxValue(final Tuple[] tuples);

	public double getCombinedMeasureValue(double leftValue, double rightValue);
	
	public double getBetterScore(double score1, double score2);

	public String getName();
}
