package edu.emory.mathcs.measures;

import java.util.Map;
import java.util.TreeMap;

public class MeasuresFactory {

	private static Map<String, Measure> measures = new TreeMap<String, Measure>();
	
	private MeasuresFactory() 
	{
	}

	public static void registerMeasure(String name, Measure m)
	{
		MeasuresFactory.measures.put(name, m);
	}

	public static void unregisterMeasure(String name)
	{
		MeasuresFactory.measures.remove(name);
	}
	
	public static Measure getMeasure(String measureName)
	{
		return MeasuresFactory.measures.get(measureName);
	}
}
