package edu.emory.mathcs.measures.privacy;

import java.util.Map;

import edu.emory.mathcs.Tuple;
import edu.emory.mathcs.TuplesGroup;
import edu.emory.mathcs.measures.Measure;

public class DisclosureProbabilityAvg implements Measure
{
	public static final String NAME = "DisclosureProbabilityAvg";
	
	@Override
	public double getBetterScore(double score1, double score2)
	{
		return Math.min(score1, score2);
	}

	@Override
	public double getCombinedMeasureValue(double leftValue, double rightValue)
	{
		return Double.NaN;
	}

	@Override
	public double getMaxValue(Tuple[] tuples)
	{
		return Double.NaN;
	}

	@Override
	public double getMinValue(Tuple[] tuples)
	{
		return Double.NaN;
	}

	@Override
	public String getName()
	{
		return DisclosureProbabilityAvg.NAME;
	}

	@Override
	public double getValue(TuplesGroup tuples)
	{
		Map<Tuple, Double> probs = DisclosureProbability.getDisclosureProbabilities(tuples);//tuples.getDisclosureProbabilities();
		double sum = 0.0;
		for (Double value : probs.values()) {
				sum += value;
		}
		
		return sum / (double) probs.size();
	}

	@Override
	public int compareTo(Measure o)
	{
		return o.getName().compareTo(this.getName());
	}

}
