package edu.emory.mathcs.measures.utility;

import edu.emory.mathcs.Tuple;
import edu.emory.mathcs.TuplesGroup;
import edu.emory.mathcs.measures.Measure;

public class Discernibility implements Measure
{
	public static final String NAME = "Discernibility";
	
	@Override
	public double getBetterScore(double score1, double score2)
	{
		return Math.min(score1, score2);
	}

	@Override
	public double getCombinedMeasureValue(double leftValue, double rightValue)
	{
		return leftValue + rightValue;
	}

	@Override
	public double getMaxValue(Tuple[] tuples)
	{
		return Double.NaN;
	}

	@Override
	public double getMinValue(Tuple[] tuples)
	{
		return Double.NaN;
	}

	@Override
	public String getName()
	{
		return Discernibility.NAME;
	}

	@Override
	public double getValue(TuplesGroup tuples)
	{
		if (tuples.hasSubGroups())
		{
			return this.getValue(tuples.getLeftChild()) + this.getValue(tuples.getRightChild());
		}
		else 
		{
			return tuples.getNumTuples() * tuples.getNumTuples();
		}
	}

	@Override
	public int compareTo(Measure o)
	{
		return o.getName().compareTo(this.getName());
	}

}
