package edu.emory.mathcs.privacy;

import edu.emory.mathcs.TuplesGroup;

public class DummyChecker implements PrivacyChecker {

	public static final String NAME = "DummyChecker";
	
	private boolean value;
	
	public DummyChecker(boolean value)
	{
		this.value = value;
	}
	
	@Override
	public boolean isAnonymized(TuplesGroup tuples) {
		return this.value;
	}

	@Override
	public boolean isMonotonic()
	{
		return true;
	}

	@Override
	public double getPrivacyFitness(TuplesGroup tuples)
	{
		if (this.value)
			return 1.0;
		return 0.0;
	}

}
