package edu.emory.mathcs.privacy;

import java.util.Map;
import java.util.TreeMap;

public class PrivacyCheckerFactory {

	private static Map<String, PrivacyChecker> checkers = new TreeMap<String, PrivacyChecker>();

	private PrivacyCheckerFactory() {
	}

	public static void registerPrivacyChecker(String name, PrivacyChecker checker) {
		PrivacyCheckerFactory.checkers.put(name, checker);
	}

	public static void unregisterChecker(String name, PrivacyChecker checker) {
		PrivacyCheckerFactory.checkers.remove(name);
	}

	public static PrivacyChecker getChecker(String checkerName) {
		return PrivacyCheckerFactory.checkers.get(checkerName);
	}

}
