package edu.emory.mathcs.privacy;

import edu.emory.mathcs.TuplesGroup;
import edu.emory.mathcs.measures.privacy.DeltaGrowthGroup;

public class T_closeness implements PrivacyChecker {

	private double t;
	public DeltaGrowthGroup emed;
	
	public T_closeness(double t, DeltaGrowthGroup emed)
	{
		this.t = t;
		this.emed = emed;
	}
	
	@Override
	public boolean isAnonymized(TuplesGroup tuples) {
		return this.emed.getValue(tuples) <= this.t;
	}

	@Override
	public boolean isMonotonic()
	{
		return false;
	}

	@Override
	public double getPrivacyFitness(TuplesGroup tuples)
	{
		double privacyLevel = 0.0;

		if (tuples.hasSubGroups() == false)
		{
			privacyLevel = this.t / this.emed.getValue(tuples);
		}
		else
		{
			privacyLevel = Math.min(this.getPrivacyFitness(tuples.getLeftChild()), this.getPrivacyFitness(tuples.getRightChild()));
		}

		return privacyLevel;
	}
}
